#Использовать datetime

Перем ОписаниеОшибкиКласса;
Перем ФорматДаты;

Процедура ПриСозданииОбъекта(Знач ВходящийФормат = "yyyy-MM-dd HH:mm:ss")
	
	ФорматДаты = ВходящийФормат;

КонецПроцедуры

// Возвращает строковое представление значения типа
//
// Параметры:
//   Значение - Дата - значение типа
//
//  Возвращаемое значение:
//   строка - значение в строковом представлении
//
Функция ВСтроку(Значение) Экспорт
	
	Возврат Формат(Значение, ФорматДаты);
	
КонецФункции

// Преобразует и устанавливает входящее значение к значению типа
//
// Параметры:
//   ВходящаяСтрока - строка - строковое представление значения
//   Значение - Дата - переменная для установки значения
//
//  Возвращаемое значение:
//   дата - конвертированные значение
//
Функция УстановитьЗначение(Знач ВходящаяСтрока, Значение) Экспорт
	
	Попытка
		ПроцессорДаты = Новый ДатаВремя();

		Значение = ПроцессорДаты.СтрокаВДату(ВходящаяСтрока, ФорматДаты);
	Исключение
		Значение = Дата("20010101");
		ОписаниеОшибкиКласса = ОписаниеОшибки();
	КонецПопытки;

	Возврат Значение;

КонецФункции 

// Возвращает описание ошибки и устанавливает признак ошибки 
//
// Параметры:
//   ЕстьОшибка - булево - произвольная переменная
//
//  Возвращаемое значение:
//   Строка - описание текущей ошибки преобразования типов
//
Функция Ошибка(ЕстьОшибка = Ложь) Экспорт
	
	Если НЕ ПустаяСтрока(ОписаниеОшибкиКласса) Тогда
		ЕстьОшибка = Истина;
	КонецЕсли;

	Возврат ОписаниеОшибкиКласса;
	
КонецФункции

ОписаниеОшибкиКласса = "";